<template>
    <v-card v-bind:class="{'ma-3': !$vuetify.breakpoint.smAndDown}" v-show="!hidden">
        <v-img
                :src="img"
                aspect-ratio="2.75"
                v-if="img"
        ></v-img>
        <v-layout row justify-space-between>
            <v-flex class="ma-0">
                <v-card-title primary-title>
                    <div v-if="!edit.title">
                        <h3 class="headline mb-0">{{ editable.title }}</h3>
                    </div>

                    <div v-else-if="edit.title">
                        <v-text-field label="Pealkiri" v-model="editable.title"
                                      class="headline ma-0 pa-0"
                                      append-icon="done"
                                      @click:append="updateVote"
                                      :loading="loaders.title"
                        >

                        </v-text-field>
                    </div>

                    &nbsp;
                    <v-icon v-if="isStaff && !edit.title" class="edit" @click="edit.title = !edit.title">create</v-icon>
                </v-card-title>
                <v-card-text>
                    <div v-if="!edit.description" class="break">
                        {{ text }}
                        <span v-if="isCollapsed">
                                ... <a @click="isCollapsed = !isCollapsed">Loe edasi</a>
                            </span>
                        <v-icon v-if="isStaff" class="edit" @click="edit.description = !edit.description">create
                        </v-icon>
                    </div>
                    <div v-else-if="edit.description">
                        <v-textarea label="Kirjeldus" v-model="editable.description"
                                    class="ma-0 pa-0"
                                    append-icon="done"
                                    @click:append="updateVote"
                                    :loading="loaders.description"
                        >

                        </v-textarea>
                    </div>
                </v-card-text>


            </v-flex>
            <v-flex shrink class="pa-2">
                <span class="green--text" style="font-size: 20px">{{ yes }}</span>
                <br>
                <span class="red--text" style="font-size: 20px">{{ no }}</span>
            </v-flex>
        </v-layout>
        <v-card-actions class="">
            <v-layout row>
                <v-btn small
                       class="white--text elevation-0"
                       @click="submitVote('yes')"
                       :color="canVote(0) ? 'grey': 'green'">
                    JAH
                </v-btn>
                <v-btn small
                       class="white--text elevation-0"
                       @click="submitVote('no')"
                       :color="canVote(1) ? 'grey': 'red'"
                >
                    EI
                </v-btn>
                <v-icon v-if="user.role === 'admin' || user.role === 'moderator'"
                        class="delete"
                        @click="deleteVote"
                >
                    delete_forever
                </v-icon>
                <v-spacer></v-spacer>
                <v-tooltip top v-if="this.created_by !== undefined && this.created_at !== undefined">
                    <template v-slot:activator="{ on }">
                        <v-icon v-on="on">info</v-icon>
                    </template>
                    <span>Looja: {{this.created_by.name}} </span>
                    <br>
                    <span>Loodud: {{this.created_at}} </span>
                </v-tooltip>
            </v-layout>
        </v-card-actions>
        <v-layout row>
            <v-expand-transition>
                <v-progress-linear v-show="isLoading" :indeterminate="true" class="ma-0"></v-progress-linear>
            </v-expand-transition>
        </v-layout>
    </v-card>
</template>

<script>
    import axios from "axios";
    import {mapActions, mapGetters} from "vuex";

    export default {
        name: "Vote",
        props: {
            id: Number,
            title: String,
            description: String,
            img: String,
            yes: Number,
            no: Number,
            created_by: Object,
            created_at: String

        },

        data() {
            return {
                isCollapsed: false,
                isLoading: false,
                edit: {
                    title: false,
                    description: false
                },
                editable: {
                    title: this.title,
                    description: this.description
                },
                hidden: false,
                loaders: {
                    title: false,
                    description: false
                }

            }
        },

        created() {
            if (this.description.length > 200) this.isCollapsed = true;
        },

        computed: {
            text() {
                if (this.isCollapsed) {
                    return this.editable.description.substr(0, 200);
                }
                return this.editable.description;
            },
            ...mapGetters({
                user: 'user',
                isStaff: 'isStaff'
            }),
            ...mapGetters('voting', {
                hasUserVotedOn: 'hasUserVotedOn',
                // isLoading: 'loading'
            }),
        },
        methods: {
            ...mapActions('voting', {
                vote: 'vote'
            }),
            submitVote(value) {
                this.isLoading = true;
                this.vote({value: value, vote: {id: this.id}, user: this.user})
                    .then(() => this.isLoading = false)
                    .catch(() => this.isLoading = false);
            },
            canVote(val) {
                return this.hasUserVotedOn(this.id, this.user.id) === val || this.hasUserVotedOn === undefined;
            },
            deleteVote() {
                this.$store.dispatch('voting/delete', this.id)
                    .then(() => this.hidden = true);
            },
            updateVote() {
                this.loaders.title = 'primary';
                this.loaders.description = 'primary';
                this.$store.dispatch('voting/update', {
                    id: this.id,
                    title: this.editable.title,
                    description: this.editable.description,
                })
                    .then(() => {
                        this.edit.title = false;
                        this.edit.description = false;
                        this.loaders.title = false;
                        this.loaders.description = false;
                    })
            }
        }
    }
</script>

<style lang="scss" scoped>
    .delete {
        &:hover {
            color: black;
        }

        color: red;
        font-size: 30px;
        cursor: pointer;
    }

    .edit {
        &:hover {
            color: black;
        }

        cursor: pointer;
    }

    .break {
        overflow-wrap: break-word;
        word-wrap: break-word;
        -ms-hyphens: auto;
        -moz-hyphens: auto;
        -webkit-hyphens: auto;
        hyphens: auto;
    }
</style>